part of xpx_crypto;

Uint8List bytesFromList(List<int> lst) => new Uint8List.fromList(lst);

int bytesToInteger(List<int> bytes) {
  num value = 0;
  // ignore: parameter_assignments
  bytes = bytes.sublist(0, 32);
  for (var i = 0; i < bytes.length; i++) {
    value += bytes[i] * pow(256, i);
  }
  return value.toInt();
}

var _byteMask = new BigInt.from(0xff);

/// Encode a BigInt into bytes using big-endian encoding.
Uint8List encodeBigInt(BigInt number) {
  // Not handling negative numbers. Decide how you want to do that.
  final int size = (number.bitLength + 7) >> 3;
  final result = new Uint8List(size);
  for (int i = 0; i < size; i++) {
    result[size - i - 1] = (number & _byteMask).toInt();
    // ignore: parameter_assignments
    number = number >> 8;
  }
  return result;
}

Uint8List integerToBytes(int e, int length) {
  final byteList = new Uint8List(length);
  for (var i = 0; i < length; i++) {
    byteList[0 + i] = e >> (i * 8);
  }
  return byteList;
}

Uint8List addUint8List(Uint8List a, Uint8List b) {
  final Uint8List hash = Uint8List(b.length + a.length);
  for (int i = 0; i < a.length; i++) {
    hash[i] = a[i];
  }
  for (int i = 0; i < b.length; i++) {
    hash[i + a.length] = b[i];
  }
  return hash;
}
